
public class KMeans {
	static int maxIteration = 10;
	static int currIteration =0;
	public static void main(String[] args) {
		int dataSet[] = { 2, 4, -10, 12, 3, 20, 30, 11 ,25,17,23}; 
		int k = 3;
		int len = dataSet.length;
		int mid = len/2;
		int centroid[][] = new int[][] { { 0, 0, 0 }, { dataSet[0], dataSet[mid], dataSet[len-1] } };
		calculateCentroid(dataSet, k, centroid);

	}

	public static int[][] calculateCentroid(int dataSet[], int k, int centroid[][]) {
		currIteration++;
		int dist[][] = new int[k][dataSet.length];
		int cluster[] = new int[dataSet.length];
		int clusterCount[] = new int[k];

		centroid[0] = centroid[1];
		centroid[1] = new int[] { 0, 0, 0 };
		System.out.println("Iteration " + currIteration);
		System.out.println("*********** Starting to get new centroid ***********");

		for (int i = 0; i < k; i++) {
			for (int j = 0; j < dataSet.length; j++) {
				dist[i][j] = Math.abs(dataSet[j] - centroid[0][i]);
				System.out.print(dist[i][j] + " ,");
			}
			System.out.println();
		}

		for (int j = 0; j < dataSet.length; j++) {
			int nearestDist = 0;
			if (dist[0][j] < dist[1][j] && dist[0][j] < dist[2][j])
				nearestDist = 0;
			if (dist[1][j] < dist[0][j] && dist[1][j] < dist[2][j])
				nearestDist = 1;
			if (dist[2][j] < dist[0][j] && dist[2][j] < dist[1][j])
				nearestDist = 2;

			centroid[1][nearestDist] = centroid[1][nearestDist] + dataSet[j];
			clusterCount[nearestDist] = clusterCount[nearestDist] + 1;
			cluster[j] = nearestDist;

		}

		System.out.println("************************************* ");

		System.out.println("New clusters are ");

		for (int i = 0; i < k; i++) {
			System.out.print("C" + (i + 1) + ": ");
			for (int l = 0; l < dataSet.length; l++) {
				if (cluster[l] == i)
					System.out.print(dataSet[l] + " ,");

			}
			System.out.println();
		}
		System.out.println("*********************************** ");

		System.out.println("New centroid is ");

		for (int j = 0; j < k; j++) {
			centroid[1][j] = centroid[1][j] / clusterCount[j];
			System.out.print(centroid[1][j] + ",");
		}
		System.out.println();

		boolean isAchived = isCentroidRepeating(centroid,k);

		if (!isAchived) {

			calculateCentroid(dataSet, k, centroid);
		}

		if (isAchived) {
			printfFinalCluster(dataSet,cluster,k);
		}

		return centroid;

	}
	
	public static boolean isCentroidRepeating(int[][] centroid,int k) {
		if(currIteration > maxIteration) {
			return true;
		}
		boolean isAchived = true;
		for (int j = 0; j < k; j++) {
			if (isAchived && centroid[0][j] == centroid[1][j]) {
				isAchived = true;
				continue;
			}
			isAchived = false;
		}

			return isAchived;
	}
	public static void printfFinalCluster(int[] dataSet, int[] cluster,int k) {
		System.out.println("******************************** ");
		System.out.println(" Final Cluster is ");
		for (int i = 0; i < k; i++) {
			System.out.print("C" + (i + 1) + ":");
			for (int j = 0; j < dataSet.length; j++) {
				if (cluster[j] == i)
					System.out.print(dataSet[j] + " ,");

			}
			System.out.println();
		}
	}
}
